<?php
/**
 * @package Osd_File_Fetch
 * @version 1.0
 */
/*
Plugin Name: OSD File Fetch
Plugin URI: http://www.onlinesolutionsdevelopment.com
Description: This plugin allows you to download remote files to your server
Author: Direct Access SRL
Version: 1.0
Author URI: http://www.onlinesolutionsdevelopment.com
*/


function osd_file_fetch_menu() {
  add_media_page('OSD File Fetch Options', 'OSD File Fetch', 'manage_options', 'osd-file-fetch', 'osd_file_fetch_menu_options');
}

function osd_file_fetch_menu_options() 
{

  if (!current_user_can('manage_options'))  
  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
  }
  $msg_to_user = '';
  if (isset($_POST['osd_save_file']))
  {
	$url = filter_input(INPUT_POST, 'source_url', FILTER_VALIDATE_URL);
	$filepath = array();
	if (isset($_POST['filepath']))
	{
		$filepath = $_POST['filepath'];
	}
	$path = ABSPATH . implode('/', $filepath);
	$filename = filter_input(INPUT_POST, 'filename', FILTER_SANITIZE_STRING);
	
	if (empty($url))
	{
		$msg_to_user = '<h3 style="color:red;">Invalid url.</h3>';
	}
	else 
	{
		if (is_dir($path))
		{
			if (empty($filename))
			{
				$msg_to_user = '<h3 style="color:red;">Invalid filename selected.</h3>';
			}
			else
			{
				$filecontent = file_get_contents($url);
				if (empty($filecontent))
				{
					$msg_to_user = '<h3 style="color:red;">Could not fetch file.</h3>';
				}
				else
				{
					if (file_put_contents($path . '/' . $filename, $filecontent))
					{
						$msg_to_user = '<h3 style="color:green;">File saved successfully.</h3>';
					}
					else 
					{
						$msg_to_user = '<h3 style="color:red;">Could not save file, please check directory permissions.</h3>';
					}
				}
			}
		}
		else 
		{
			$msg_to_user = '<h3 style="color:red;">Invalid dir selected.</h3>';
		}
	}
	
  }
  echo $msg_to_user;
  
  $current_dir = scandir(ABSPATH);
  
  $dirs = array();
  foreach ($current_dir as $key=>$value)
  {
	if ('.' != $value && '..' != $value)
	{
		if (is_dir(ABSPATH . $value))
		{
			$dirs[] = $value;
		}
	}
  }

 echo '
	
<h2>OSD FILE FETCH</h2>

<div class="tool-box">
	<form action="" method="post">
		<table>
			<tr>
				<td>Enter source url:</td> <td><input type="text" name="source_url" id="source_url" size="100" onblur="update_osd_filename();" /></td>
			</tr>
			<tr>
				<td>
				Select destination path:
				</td>
				<td>
					<span id="osd_select_container">
						<span>
					<select class="filepath" onchange="get_path(this);" name="filepath[]">
						<option value="">--select--</option>
				';
	foreach ($dirs as $key=>$value)
	{
		echo '<option value="'.$value.'">'.$value.'</option>';
	}
				
		
echo '
			</select>
				<span>
				</span>
			</td>
			</tr>
			<tr>
				
				<td>
					File name:
				</td>
				<td>
					<input type="text" name="filename" id="filename" />
				</td>
				
			</tr>
			<tr>
				<td colspan="2">
					<input type="submit" name="osd_save_file" value="Save File" />
				</td>
			</tr>
		</table>
	</form>
</div>
 
 
 <script type="text/javascript">
	function getElementsByClassName(className, tag, elm)
	{
		var testClass = new RegExp("(^|\\s)" + className + "(\\s|$)");
		var tag = tag || "*";
		var elm = elm || document;
		var elements = (tag == "*" && elm.all)? elm.all : elm.getElementsByTagName(tag);
		var returnElements = [];
		var current;
		var length = elements.length;
		for(var i=0; i<length; i++)
		{
			current = elements[i];
			if(testClass.test(current.className))
			{
				returnElements.push(current);
			}
		}
		return returnElements;
	}
	// took this one from http://phpjs.org/ I like that library a lot :)
	function count (mixed_var, mode) {
		// http://kevin.vanzonneveld.net
		// +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// +      input by: Waldo Malqui Silva
		// +      bugfixed by: Soren Hansen
		// +      input by: merabi
		// +      improved by: Brett Zamir (http://brett-zamir.me)
		// *     example 1: count([[0,0],[0,-4]], "COUNT_RECURSIVE");
		// *     returns 1: 6
		// *     example 2: count({"one" : [1,2,3,4,5]}, "COUNT_RECURSIVE");
		// *     returns 2: 6

		var key, cnt = 0;

		if (mixed_var === null){
			return 0;
		} else if (mixed_var.constructor !== Array && mixed_var.constructor !== Object){
			return 1;
		}

		if (mode === "COUNT_RECURSIVE") {
			mode = 1;
		}
		if (mode != 1) {
			mode = 0;
		}

		for (key in mixed_var){
			if (mixed_var.hasOwnProperty(key)) {
				cnt++;
				if ( mode==1 && mixed_var[key] && (mixed_var[key].constructor === Array || mixed_var[key].constructor === Object) ){
					cnt += this.count(mixed_var[key], 1);
				}
			}
		}

		return cnt;
	}
	
	function removeElement(elm)
	{
		elm.parentNode.removeChild(elm);
	}

	function get_path(element)
	{
		var paths = getElementsByClassName("filepath");
		
		var remove = 0;
		
		var selected_paths = new Array();
		
		var nr_elements = 0;
		
		for (i in paths)
		{
			if (remove)
			{
				removeElement(paths[i]);
			}
			else 
			{
				nr_elements = selected_paths.push(paths[i]);
			}
			if (paths[i] == element)
			{
				remove = 1;
			}
		}
		
		if (element.value != "")
		{
			if (nr_elements)
			{
				var selected_str = selected_paths[0].value;
				for (i=1;i<count(selected_paths);i++)
				{
					selected_str += "," + selected_paths[i].value;
				}
				
				var xmlHttp=null;
				
				try
				{
					// Firefox, Internet Explorer 7. Opera 8.0+, Safari.
					xmlHttp = new XMLHttpRequest();
				}
				catch (e)
				{
					// Internet Explorer 6.
					try
					{
						xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
					}
					catch (e)
					{
						try
						{
							xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
						}
						catch (e)
						{
							return false;
						}
					}
				}
				

				 xmlHttp.open("POST", "'.get_admin_url().'upload.php?page=osd-file-fetch&osd_get_dir=1", true);
				 
				 xmlHttp.onreadystatechange=function() 
				 {
					if(xmlHttp.readyState==4)
					{
						response=xmlHttp.responseText;
						
						new_el = document.createElement("span");
						new_el.innerHTML = response;
						document.getElementById("osd_select_container").appendChild(new_el);
						xmlHttp=null;
					}
				}
				
				parameterString = "dirs=" + selected_str;
				
				// set the necessary request headers
				xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
				xmlHttp.setRequestHeader("Content-length", parameterString.length);
				xmlHttp.setRequestHeader("Connection", "close");
				
				xmlHttp.send(parameterString);
			}
		}
	}
	
	function update_osd_filename()
	{
		var parts = document.getElementById("source_url").value.split("/");
		document.getElementById("filename").value = parts[count(parts)-1];
	}
		
	
 </script>
 
 ';
 
 

}

function osd_get_next_dir()
{
	if (!isset($_GET['osd_get_dir']))
	{
		return false;
	}
	if (!isset($_POST['dirs']) || empty($_POST['dirs']))
	{
		echo ' ';die;
	}
	
	$dirs = filter_input(INPUT_POST, 'dirs', FILTER_SANITIZE_STRING);
	$dirs = explode(',', $dirs);
	$dirs = ABSPATH . implode('/', $dirs) . '/';
	if (file_exists($dirs) && is_dir($dirs) )
	{
		$array = scandir($dirs);
		
		$next_lvl = array();
		foreach ($array as $key=>$value)
		{
			if ('.' != $value && '..' != $value)
			{
				if (is_dir($dirs . $value))
				{
					$next_lvl[] = $value;
				}
			}
		}
		
		if (!count($next_lvl))
		{
			echo ' ';die;
		}
		
		$select = ' 
					<select class="filepath" onchange="get_path(this);" name="filepath[]">
						<option value="">--select--</option>
		';
		
		foreach ($next_lvl as $key=>$value)
		{
			$select .= '
							<option value="'.$value.'">'.$value.'</option>
			';
		}
		
		$select .= '
						</select>
		';
		
		echo $select;
	}
	else 
	{
		echo '';
	}
	die;
}

add_action('init', 'osd_get_next_dir');
add_action('admin_menu', 'osd_file_fetch_menu');

?>